diff -ur gradle-1.0.orig/subprojects/core/src/main/groovy/org/gradle/api/JavaVersion.java gradle-1.0/subprojects/core/src/main/groovy/org/gradle/api/JavaVersion.java
--- gradle-1.0.orig/subprojects/core/src/main/groovy/org/gradle/api/JavaVersion.java	2012-04-25 01:27:12.000000000 +0300
+++ gradle-1.0/subprojects/core/src/main/groovy/org/gradle/api/JavaVersion.java	2012-07-14 00:30:20.989961192 +0300
@@ -24,7 +24,7 @@
  * An enumeration of Java versions.
  */
 public enum JavaVersion {
-    VERSION_1_1(false), VERSION_1_2(false), VERSION_1_3(false), VERSION_1_4(false), VERSION_1_5(true), VERSION_1_6(true), VERSION_1_7(true);
+    VERSION_1_1(false), VERSION_1_2(false), VERSION_1_3(false), VERSION_1_4(false), VERSION_1_5(true), VERSION_1_6(true), VERSION_1_7(true), VERSION_1_8(true);
 
     private final boolean hasMajorVersion;
 
@@ -57,7 +57,10 @@
 
         Matcher matcher = Pattern.compile("1\\.(\\d)(\\D.*)?").matcher(name);
         if (matcher.matches()) {
-            return values()[Integer.parseInt(matcher.group(1)) - 1];
+            int versionIdx = Integer.parseInt(matcher.group(1)) - 1;
+            if (versionIdx >= 0 && versionIdx < values().length) {
+                return values()[Integer.parseInt(matcher.group(1)) - 1];
+            }
         }
         throw new IllegalArgumentException(String.format("Could not determine java version from '%s'.", name));
     }
diff -ur gradle-1.0.orig/subprojects/core/src/test/groovy/org/gradle/api/JavaVersionTest.java gradle-1.0/subprojects/core/src/test/groovy/org/gradle/api/JavaVersionTest.java
--- gradle-1.0.orig/subprojects/core/src/test/groovy/org/gradle/api/JavaVersionTest.java	2012-04-25 01:27:12.000000000 +0300
+++ gradle-1.0/subprojects/core/src/test/groovy/org/gradle/api/JavaVersionTest.java	2012-07-14 00:29:35.120208897 +0300
@@ -43,6 +43,7 @@
         assertThat(JavaVersion.toVersion("5"), equalTo(JavaVersion.VERSION_1_5));
         assertThat(JavaVersion.toVersion("6"), equalTo(JavaVersion.VERSION_1_6));
         assertThat(JavaVersion.toVersion("7"), equalTo(JavaVersion.VERSION_1_7));
+        assertThat(JavaVersion.toVersion("1.8.0-ea"), equalTo(JavaVersion.VERSION_1_8));
     }
 
     @Test
@@ -50,7 +51,7 @@
         conversionFails("1");
         conversionFails("2");
 
-        conversionFails("8");
+        conversionFails("9");
 
         conversionFails("a");
         conversionFails("");
@@ -60,6 +61,8 @@
         conversionFails("1.10");
         conversionFails("2.0");
         conversionFails("1_4");
+        conversionFails("1.9.0-ea");
+        conversionFails("1.10.0");
     }
 
     @Test
@@ -81,7 +84,7 @@
     public void failsToConvertNumberToVersionForUnknownVersion() {
         conversionFails(1);
         conversionFails(2);
-        conversionFails(8);
+        conversionFails(9);
         conversionFails(1.21);
         conversionFails(2.0);
         conversionFails(4.2);
